"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.JsEditor = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _tab = _interopRequireDefault(require("@alifd/next/lib/tab"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _dialog = _interopRequireDefault(require("@alifd/next/lib/dialog"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireWildcard(require("react"));
var _lowcodePluginBaseMonacoEditor = _interopRequireDefault(require("@alilc/lowcode-plugin-base-monaco-editor"));
var _ErrorTip = require("../ErrorTip");
var _config = require("../../config");
var _utils = require("../../utils");
require("./JsEditor.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
//const LIFECYCLES_FUNCTION_MAP = {
//  react: ['constructor', 'render', 'componentDidMount', 'componentDidUpdate', 'componentWillUnmount', 'componentDidCatch'],
//};

var LIFECYCLES_FUNCTION_MAP = {
  react: ['setup', 'onBeforeMount', 'onMounted', 'onBeforeUpdate', 'onUpdated', 'onBeforeUnmount', 'onUnmounted', 'onActivated', 'onDeactivated', 'onErrorCaptured']
};
var JsEditor = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(JsEditor, _PureComponent);
  function JsEditor() {
    var _this$props$jsCode;
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    _this.state = {
      errorInfo: null,
      hasError: false,
      code: (_this$props$jsCode = _this.props.jsCode) !== null && _this$props$jsCode !== void 0 ? _this$props$jsCode : _config.defaultCode
    };
    _this.monaco = void 0;
    _this.monacoEditor = void 0;
    _this.lastErrorDecoration = void 0;
    _this.disposeProvider = void 0;
    return _this;
  }
  var _proto = JsEditor.prototype;
  // get schema from code
  _proto.getSchemaFromCode = function getSchemaFromCode() {
    var _this$monacoEditor$ge, _this$monacoEditor, _this$monacoEditor$ge2;
    var code = (_this$monacoEditor$ge = (_this$monacoEditor = this.monacoEditor) === null || _this$monacoEditor === void 0 ? void 0 : (_this$monacoEditor$ge2 = _this$monacoEditor.getModel()) === null || _this$monacoEditor$ge2 === void 0 ? void 0 : _this$monacoEditor$ge2.getValue()) !== null && _this$monacoEditor$ge !== void 0 ? _this$monacoEditor$ge : this.state.code;
    var ast = (0, _utils.transformAst)(code);
    var _getMethods = (0, _utils.getMethods)(ast),
      methods = _getMethods.methods,
      errorsByMethods = _getMethods.errorsByMethods;
    var lifeCycles = {};
    var newMethods = {};
    Object.keys(methods).forEach(function (method) {
      if (LIFECYCLES_FUNCTION_MAP.react.indexOf(method) >= 0) {
        lifeCycles[method] = methods[method];
      } else {
        newMethods[method] = methods[method];
      }
    });
    if (Object.keys(errorsByMethods).length > 0) {
      _dialog["default"].alert({
        title: _config.WORDS.title,
        content: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, _config.WORDS.functionParseError, Object.entries(errorsByMethods).map(function (_ref, index) {
          var key = _ref[0],
            err = _ref[1];
          return /*#__PURE__*/_react["default"].createElement("p", {
            key: index
          }, key, ": ", err);
        }))
      });
    }
    return {
      state: (0, _utils.stateParser)(ast),
      methods: newMethods,
      lifeCycles: lifeCycles,
      originCode: code
    };
  };
  _proto.editorDidMount = /*#__PURE__*/function () {
    var _editorDidMount = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(monaco, editor) {
      var _this$disposeProvider,
        _this$disposeProvider2,
        _this2 = this;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            this.monacoEditor = editor;
            this.monaco = monaco;
            monaco.languages.typescript.javascriptDefaults.setDiagnosticsOptions({
              noSemanticValidation: false,
              noSyntaxValidation: false,
              noSuggestionDiagnostics: true
            });
            monaco.languages.typescript.javascriptDefaults.setCompilerOptions({
              target: monaco.languages.typescript.ScriptTarget.ES6,
              allowNonTsExtensions: true,
              moduleResolution: monaco.languages.typescript.ModuleResolutionKind.NodeJs,
              module: monaco.languages.typescript.ModuleKind.CommonJS,
              noEmit: true,
              esModuleInterop: true,
              jsx: monaco.languages.typescript.JsxEmit.React,
              reactNamespace: "React",
              allowJs: true,
              typeRoots: ["node_modules/@types"]
            });

            // 将 babel 报错提示在这里
            (_this$disposeProvider = this.disposeProvider) === null || _this$disposeProvider === void 0 ? void 0 : (_this$disposeProvider2 = _this$disposeProvider.dispose) === null || _this$disposeProvider2 === void 0 ? void 0 : _this$disposeProvider2.call(_this$disposeProvider);
            this.disposeProvider = monaco.languages.registerHoverProvider('javascript', {
              provideHover: function provideHover(model, position) {
                var _this2$state$errorLoc;
                if (((_this2$state$errorLoc = _this2.state.errorLocation) === null || _this2$state$errorLoc === void 0 ? void 0 : _this2$state$errorLoc.line) === position.lineNumber) {
                  var _this2$state$errorLoc2, _this2$state$errorLoc3, _this2$state$errorLoc4;
                  return {
                    range: new monaco.Range(position.lineNumber, (_this2$state$errorLoc2 = _this2.state.errorLocation) === null || _this2$state$errorLoc2 === void 0 ? void 0 : _this2$state$errorLoc2.column, position.lineNumber, ((_this2$state$errorLoc3 = (_this2$state$errorLoc4 = _this2.state.errorLocation) === null || _this2$state$errorLoc4 === void 0 ? void 0 : _this2$state$errorLoc4.column) !== null && _this2$state$errorLoc3 !== void 0 ? _this2$state$errorLoc3 : 0) + 1),
                    contents: [{
                      value: "**" + _this2.state.errorInfo + "**",
                      supportHtml: true,
                      isTrusted: true
                    }]
                  };
                }
                return null;
              }
            });

            // monaco.languages.typescript.typescriptDefaults.addExtraLib(
            //   ReactType,
            //   `file:///node_modules/@react/types/index.d.ts`
            // );

            monaco.languages.typescript.javascriptDefaults.addExtraLib("\n        declare class Component {\n          state?: Record<string, any>;\n          setState(input: Record<string, any>, fn?: (...args: any[]) => any): void;\n          onMounted(): void;\n          onUnmounted(): void;\n          setup(): void;\n          onBeforeUnmount(): void;\n          onErrorCaptured(error: Error, info: any): void;\n        }\n      ", "ts:/component.tsx");
          case 7:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function editorDidMount(_x, _x2) {
      return _editorDidMount.apply(this, arguments);
    }
    return editorDidMount;
  }();
  _proto.focusByFunctionName = function focusByFunctionName(_ref2) {
    var _monacoEditor$getMode, _monacoEditor$getMode2;
    var functionName = _ref2.functionName;
    var monacoEditor = this.monacoEditor;
    var matchedResult = monacoEditor === null || monacoEditor === void 0 ? void 0 : (_monacoEditor$getMode = monacoEditor.getModel()) === null || _monacoEditor$getMode === void 0 ? void 0 : (_monacoEditor$getMode2 = _monacoEditor$getMode.findMatches("^\\s*(?:async)?\\s*" + functionName + "\\s*\\([\\s\\S]*\\)[\\s\\S]*\\{", false, true)) === null || _monacoEditor$getMode2 === void 0 ? void 0 : _monacoEditor$getMode2[0];
    if (matchedResult) {
      setTimeout(function () {
        monacoEditor.revealLineInCenter(matchedResult.range.startLineNumber);
        monacoEditor.setPosition({
          column: matchedResult.range.endColumn,
          lineNumber: matchedResult.range.endLineNumber
        });
        monacoEditor.focus();
      }, 100);
    }
  };
  _proto.addFunction = function addFunction(params) {
    var _monacoEditor$getMode3, _monacoEditor$getMode4;
    var monacoEditor = this.monacoEditor,
      monaco = this.monaco;
    if (!monacoEditor || !monaco) {
      return;
    }
    var count = (_monacoEditor$getMode3 = (_monacoEditor$getMode4 = monacoEditor.getModel()) === null || _monacoEditor$getMode4 === void 0 ? void 0 : _monacoEditor$getMode4.getLineCount()) !== null && _monacoEditor$getMode3 !== void 0 ? _monacoEditor$getMode3 : 0;
    var range = new monaco.Range(count, 1, count, 1);
    var functionCode = params.template ? params.template : "\n\t" + params.functionName + "(){\n\t}\n";
    monacoEditor.executeEdits('log-source', [{
      identifier: 'event_id',
      range: range,
      text: functionCode,
      forceMoveMarkers: true
    }]);
    params.functionName && this.focusByFunctionName(params);
  };
  _proto.render = function render() {
    var _this3 = this;
    var _this$state = this.state,
      code = _this$state.code,
      hasError = _this$state.hasError,
      errorInfo = _this$state.errorInfo;
    var _this$props = this.props,
      jsCode = _this$props.jsCode,
      currentTab = _this$props.currentTab,
      onTabChange = _this$props.onTabChange;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_tab["default"], {
      size: "small",
      shape: "wrapped",
      activeKey: currentTab
    }, /*#__PURE__*/_react["default"].createElement(_tab["default"].Item, {
      className: hasError ? 'tab-with-error' : '',
      title: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, code !== jsCode ? '* ' : '', "index.js"),
      key: _config.TAB_KEY.JS,
      onClick: function onClick() {
        return onTabChange(_config.TAB_KEY.JS);
      }
    })), currentTab === _config.TAB_KEY.JS && /*#__PURE__*/_react["default"].createElement("div", {
      className: "plugin-code-editor-js plugin-code-editor-inner"
    }, /*#__PURE__*/_react["default"].createElement(_lowcodePluginBaseMonacoEditor["default"], {
      value: code,
      language: "javascript",
      height: "100%",
      supportFullScreen: true,
      onChange: function onChange(newCode) {
        _this3._updateCode(newCode);
      },
      editorDidMount: function editorDidMount(monaco, editor) {
        _this3.editorDidMount(monaco, editor);
      }
    }), hasError && typeof errorInfo === 'string' ? /*#__PURE__*/_react["default"].createElement(_ErrorTip.ErrorTip, {
      errorInfo: errorInfo
    }) : null));
  };
  _proto._updateCode = function _updateCode(newCode) {
    var _this4 = this;
    var _transformJS = (0, _utils.transformJS)(newCode, _config.defaultBabelConfig),
      hasError = _transformJS.hasError,
      errorInfo = _transformJS.errorInfo,
      errorLocation = _transformJS.errorLocation;
    var monacoEditor = this.monacoEditor,
      monaco = this.monaco;
    if (!monacoEditor || !monaco) {
      return;
    }

    // const pos = monacoEditor.getPosition();
    this.setState({
      errorInfo: errorInfo,
      hasError: hasError,
      code: newCode,
      errorLocation: errorLocation
    }, function () {
      // monacoEditor.setPosition(pos);
      // update error decorations
      if (_this4.lastErrorDecoration) {
        monacoEditor.deltaDecorations(_this4.lastErrorDecoration, []);
        _this4.lastErrorDecoration = null;
      }
      if (hasError && errorLocation) {
        var _this4$monaco, _this4$monaco$editor;
        _this4.lastErrorDecoration = monacoEditor.deltaDecorations([], [{
          range: new monaco.Range(errorLocation.line, errorLocation.column + 1, errorLocation.line, errorLocation.column + 2),
          options: {
            inlineClassName: 'squiggly-error'
          },
          minimap: {
            color: {
              id: "minimap.errorHighlight"
            },
            position: (_this4$monaco = _this4.monaco) === null || _this4$monaco === void 0 ? void 0 : (_this4$monaco$editor = _this4$monaco.editor) === null || _this4$monaco$editor === void 0 ? void 0 : _this4$monaco$editor.MinimapPosition.Inline
          }
        }, {
          range: new monaco.Range(errorLocation.line, errorLocation.column, errorLocation.line, errorLocation.column),
          options: {
            isWholeLine: true,
            linesDecorationsClassName: 'plugin-code-editor-error-line'
          }
        }]);
      }
    });
  };
  return JsEditor;
}(_react.PureComponent);
exports.JsEditor = JsEditor;
JsEditor.defaultProps = {};